
emma = Line('emma')
xpas = (10,10,10)

cells = 42
angle = 360/cells
d_offset = -34.048 * mm
f_offset = -7.514 * mm

#lengths
ld = 210 * mm
sd = 50 * mm
fq = 58.782 * mm
dq = 75.699 * mm

# quad radius
fr = 37 * mm
dr = 53 * mm

#field
fb = -6.695 * fr * T
db = 4.704 * dr * T


ob = OBJET2()
rigidity = ke_to_rigidity(10e6, 0.51099892e6)
ob.set(BORO=-rigidity)
ob.add(Y=0.456, T=-38.1, D=1)
emma.add(ob)

emma.add(ELECTRON())

emma.add(DRIFT('ld', XL=ld/cm/2))
emma.add(CHANGREF(ALE=angle))

emma.add(CHANGREF(YCE=d_offset/cm))
emma.add(QUADRUPO('defoc', XL=dq/cm, R_0=dr/cm, B_0=db/kgauss, XPAS=xpas, KPOS=1))
emma.add(CHANGREF(YCE=-d_offset/cm))

emma.add(DRIFT('sd', XL=sd/cm))

emma.add(CHANGREF(YCE=f_offset/cm))
emma.add(QUADRUPO('foc', XL=fq/cm, R_0=fr/cm, B_0=fb/kgauss, XPAS=xpas, KPOS=1))
emma.add(CHANGREF(YCE=-f_offset/cm))

emma.add(DRIFT('ld', XL=ld/cm/2))

emma.add(FAISCNL(FNAME='zgoubi.fai'))

emma.add(REBELOTE(K=99, NPASS=10))

emma.add(FAISCEAU())

emma.add(END())


print emma.output()
result = emma.run()
print result.res()
result.save_fai("emma1.fai")



