from matplotlib import pyplot

emma_cell = Line('emma')
xpas = (10,10,10)
cells = 42
angle = 360/cells
d_offset = -34.048 * mm
f_offset = -7.514 * mm
#lengths
ld = 210 * mm
sd = 50 * mm
fq = 58.782 * mm
dq = 75.699 * mm
# quad radius
fr = 37 * mm
dr = 53 * mm
#field
fb = -6.695 * fr * T
db = 4.704 * dr * T


emma_cell.add(DRIFT('ld', XL=ld/cm/2))
emma_cell.add(CHANGREF(ALE=angle))
emma_cell.add(CHANGREF(YCE=d_offset/cm))
emma_cell.add(QUADRUPO('defoc', XL=dq/cm, R_0=dr/cm, B_0=db/kgauss, XPAS=xpas, KPOS=1))
emma_cell.add(CHANGREF(YCE=-d_offset/cm))
emma_cell.add(DRIFT('sd', XL=sd/cm))
emma_cell.add(CHANGREF(YCE=f_offset/cm))
emma_cell.add(QUADRUPO('foc', XL=fq/cm, R_0=fr/cm, B_0=fb/kgauss, XPAS=xpas, KPOS=1))
emma_cell.add(CHANGREF(YCE=-f_offset/cm))
emma_cell.add(DRIFT('ld', XL=ld/cm/2))

emma_line = Line("emma line")
ob = OBJET2()
rigidity = ke_to_rigidity(10e6, 0.51099892e6)
ob.set(BORO=-rigidity)
ob.add(Y=0.456, T=-38.1, D=1)
emma_line.add(ob)
emma_line.add(ELECTRON())
emma_line.add(emma_cell)
emma_line.add(FAISCNL(FNAME='zgoubi.fai'))
emma_line.add(REBELOTE(K=99, NPASS=100))
emma_line.add(END())


result = emma_line.run()
ftrack = result.get_all("fai")
print ftrack['Y']

pyplot.plot(ftrack['Y'], ftrack['T'], "b.")
pyplot.xlabel("Y (cm)")
pyplot.ylabel("T (mrad)")
pyplot.savefig("emma_phase_space.pdf")



emma_line2 = Line("emma line2")
emma_cell.full_tracking(True)
emma_line2.add(ob)
emma_line2.add(ELECTRON())
emma_line2.add(emma_cell)
emma_line2.add(END())


result = emma_line2.run()
ftrack = result.get_all("plt")
pyplot.clf()

pyplot.plot(ftrack['S'], ftrack['Y'], "b.")
pyplot.xlabel("S (cm)")
pyplot.ylabel("Y (cm)")
pyplot.savefig("emma_track.pdf")



