kurri_mag = FFAG("kurri", IL=20,
				 N=5, AT=30, RM=540,
				 KIRD=0, RESOL=2,
				 XPAS=0.25,
				 KPOS=2,
				 RE=540, RS=540
				 )

g0 = 6.3
kappa = 3
nc=4
c0, c1, c2, c3 = .1455, 2.2670, -.6395, 1.1558
big = 1e6

# mag 0
omega0_e = 4.7
omega0_s = -4.7
kurri_mag.add(ACN=0, DELTA_RM=0, BZ_0=-.6, K=0.1,
              G0_E=g0, KAPPA_E=kappa,
              NCE=nc, CE_0=c0, CE_1=c1, CE_2=c2, CE_3=c3,
			  OMEGA_E=omega0_e,
			  R1_E=big, U1_E=-big, U2_E=big, R2_E=big,
              G0_S=g0, KAPPA_S=kappa,
              NCS=nc, CS_0=c0, CS_1=c1, CS_2=c2, CS_3=c3,
			  OMEGA_S=omega0_s,
			  R1_S=big, U1_S=-big, U2_S=big, R2_S=big,
              KAPPA_L=-1)

#mag 1
omega1_e = 2.5
omega1_s = -1.765
kurri_mag.add(ACN=6.465, DELTA_RM=0, BZ_0=-.967e1, K=7.6,
              G0_E=8.3, KAPPA_E=kappa,
              NCE=nc, CE_0=c0, CE_1=c1, CE_2=c2, CE_3=c3,
			  OMEGA_E=omega1_e,
			  R1_E=big, U1_E=-big, U2_E=big, R2_E=big,
              G0_S=g0, KAPPA_S=kappa,
              NCS=nc, CS_0=c0, CS_1=c1, CS_2=c2, CS_3=c3,
			  OMEGA_S=omega1_s,
			  R1_S=big, U1_S=-big, U2_S=big, R2_S=big,
              KAPPA_L=-1)

#mag 2
omega2_e = 5.37
omega2_s = -5.37
kurri_mag.add(ACN=15, DELTA_RM=0, BZ_0=1.69055873e1, K=7.6,
              G0_E=g0, KAPPA_E=kappa,
              NCE=nc, CE_0=c0, CE_1=c1, CE_2=c2, CE_3=c3,
			  OMEGA_E=omega2_e,
			  R1_E=big, U1_E=-big, U2_E=big, R2_E=big,
              G0_S=g0, KAPPA_S=kappa,
              NCS=nc, CS_0=c0, CS_1=c1, CS_2=c2, CS_3=c3,
			  OMEGA_S=omega2_s,
			  R1_S=big, U1_S=-big, U2_S=big, R2_S=big,
              KAPPA_L=-1)


#mag 3
omega3_e = 1.765
omega3_s = -2.5
kurri_mag.add(ACN=23.535, DELTA_RM=0, BZ_0=-.967e1, K=7.6,
              G0_E=g0, KAPPA_E=kappa,
              NCE=nc, CE_0=c0, CE_1=c1, CE_2=c2, CE_3=c3,
			  OMEGA_E=omega3_e,
			  R1_E=big, U1_E=-big, U2_E=big, R2_E=big,
              G0_S=8.3, KAPPA_S=kappa,
              NCS=nc, CS_0=c0, CS_1=c1, CS_2=c2, CS_3=c3,
			  OMEGA_S=omega3_s,
			  R1_S=big, U1_S=-big, U2_S=big, R2_S=big,
              KAPPA_L=-1)

#mag 4
omega4_e = 4.7
omega4_s = -4.7
kurri_mag.add(ACN=30, DELTA_RM=0, BZ_0=-0.6, K=7.6,
              G0_E=g0, KAPPA_E=kappa,
              NCE=nc, CE_0=c0, CE_1=c1, CE_2=c2, CE_3=c3,
			  OMEGA_E=omega4_e,
			  R1_E=big, U1_E=-big, U2_E=big, R2_E=big,
              G0_S=g0, KAPPA_S=kappa,
              NCS=nc, CS_0=c0, CS_1=c1, CS_2=c2, CS_3=c3,
			  OMEGA_S=omega4_s,
			  R1_S=big, U1_S=-big, U2_S=big, R2_S=big,
              KAPPA_L=-1)

kurri_cell = Line("KURRI")
kurri_cell.add(kurri_mag)

data = gcp.get_cell_properties(cell=kurri_cell, min_ke=11e6, max_ke=150e6, ke_steps=11, particle='p', closed_orbit_init_YTZP=[-100,0,0,0], closed_orbit_range=[50,0,0,0], closed_orbit_range_count=[40,0,0,0])
print gcp.cell_properties_table(data, ["KE", "stable", "Y", "T", "NU_Y", "NU_Z"])

gcp.plot_cell_tracks(cell=kurri_cell, data=data, particle='p', output_file='kurri_cell.pdf', sector_width=250)

#gcp.plot_cell_tracks(cell=kurri_cell, data=data, particle='p', output_file='kurri_cell_mag.pdf', sector_width=250, draw_field_midplane=True, min_y=-150, max_y=50, y_steps=100, angle=-radians(15)*1000)

#data = gcp.get_cell_properties(cell=kurri_cell, min_ke=11e6, max_ke=150e6, ke_steps=1, particle='p', closed_orbit_init_YTZP=[-100,0,0,0], closed_orbit_range=[50,0,0,0], closed_orbit_range_count=[40,0,0,0])
#gcp.get_dynamic_aperture(cell=kurri_cell, data=data, particle='p', npass=20, nangles=3, tol=0.01, quick_mode="+y+z")
#print "geo", data[0]['DA']*1e6, "mm mrad"




